////////////////////////////////////////////////////////////////////
// |Ԉێ̋wKiRPUq^V~[Vj
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <random>
#include <direct.h>
#include <stdlib.h>
#include "Vector3.h"
#include "RK4_Nbody.h"
////////////////////////////////////////////////////////////////////
// p[^
////////////////////////////////////////////////////////////////////
//͈̔
double t_min = 0;
double t_max = 5.0;
double dt = 0.001;
//d͉x
double g = 10.0;
//Ђ̒
double L = 1.0;

//d͉xxNg
Vector3 vec_g = Vector3(0, 0, -g);
//
double m_box = 10.0;
double m = 1.0;

//zPʃxNg
Vector3 z_hat(0, 0, 1);

//
const int N_f_box = 20;
const int N_theta = 10;
//sԊԊu
double interval = 0.01;

//sl֐
double Q[N_f_box + 1][N_theta];

double f_box_min = -10.0 * m_box;
double f_box_max = 10.0 * m_box;
double theta_min = -90.0;
double theta_max = 90.0;

////////////////////////////////////////////////////////////////////
// qNX
////////////////////////////////////////////////////////////////////
class Particles : public RK4_Nbody {
private:
public:
	//
	double fx = 0;

	//RXgN^
	Particles(int _N, double _dt) : RK4_Nbody(_N, _dt) {}

	//fXgN^
	~Particles() {
	}

	void A(double t, Vector3 *rs, Vector3 *vs, Vector3 *out_as) {
		for (int i = 0; i < N; i++) {
			out_as[i].set(0, 0, 0);
		}

		Vector3 a_box;
		a_box.set(fx/m_box,0,0);

		//xNg
		Vector3 vec_L = rs[1] - rs[0];
		//Αx
		Vector3 v_ij = vs[1] - vs[0];

		Vector3 vec_S = vec_L / (pow(vec_L.dot(z_hat), 2) / m_box - (m + m_box) / (m * m_box) * vec_L.lengthSq()) *
			(v_ij.lengthSq() + vec_g.dot(vec_L) - a_box.dot(vec_L));

		double Sz = vec_S.dot(z_hat);

		//Ԃ։x
		out_as[0] = a_box - vec_S / m_box + Sz * z_hat / m_box;
		//Uq։x
		out_as[1] = vec_g + vec_S / m;

	};
};
//QNb^IuWFNg̐
Particles particles(2, dt);

////////////////////////////////////////////////////////////////////
// QwK
////////////////////////////////////////////////////////////////////
//wK
int Episode = 10000;
//wK
double eta = 0.1;
//
double gamma = 0.5;
//×~
double epsilon = 0.9;
//
int getThetaindex() {
	double _theta = asin( ( particles.rs[1].x - particles.rs[0].x )/L) / M_PI * 180.0;

	//̈ʒuipxj
	for (int j = 0; j < N_theta; j++) {
		double theta = theta_min + (theta_max - theta_min) / N_theta * (j+1);
		if (_theta < theta) {
			return j;
		}
	}
}

//EsV
double r_success = 0.0;
double r_failure = 0.0;

////////////////////////////////////////////////////////////////////
// C֐
////////////////////////////////////////////////////////////////////
int main(void) {
	//tH_̐
	_mkdir("output");

	std::random_device rnd; //񌈒Iȗ
	std::mt19937 mt;        //32rbgŃZkEcCX^
	mt.seed(rnd());         //̎^
	std::uniform_real_distribution<> rand_real_0_1(0, 1.0); //urand_real_0_1(mt)vPsłP̗𐶐

	std::ostringstream data1;
	std::ostringstream data2;

	//t@C̐ݒ
	std::ostringstream filename0;
	filename0 << "output/InvertedTime_gamma" << gamma <<  "_epsilon" << epsilon << ".txt";
	// t@Co̓Xg[̏
	std::ofstream ofs0(filename0.str());

	ofs0 << "#x:wK" << std::endl;
	ofs0 << "#y:" << std::endl;
	//ofs0 << "#legend:  " << std::endl;
	ofs0 << "#yrange:0 5 0.2" << std::endl;
	ofs0 << "#showLines: false false true true false false" << std::endl;
	ofs0 << "#showMarkers: true true false false true true" << std::endl;
	ofs0 << "#fills: false false false false" << std::endl;

	//t@C̐ݒ
	std::ostringstream filename1;
	filename1 <<"output/ProbabilityOfSuccess_gamma" << gamma << "_epsilon" << epsilon << ".txt";
	// t@Co̓Xg[̏
	std::ofstream ofs1(filename1.str());

	ofs1 << "#x:wK" << std::endl;
	ofs1 << "#y:" << std::endl;
	//ofs1 << "#legend:  " << std::endl;
	ofs1 << "#yrange:0 1 0.1" << std::endl;
	ofs1 << "#showLines: true true" << std::endl;
	ofs1 << "#showMarkers: false false" << std::endl;
	ofs1 << "#fills: false false" << std::endl;

	int success = 0;
	for (int episode = 0; episode <= Episode; episode++) {

		if( episode%1000 == 0 ) std::cout << std::endl << "episode:" << episode << std::endl;
		//std::cout << "-------------------------------" << std::endl;
		//std::cout << "episode:" << episode << std::endl;
		//std::cout << "-------------------------------" << std::endl;
		
		double v0 = 2.0 * (0.5 - rand_real_0_1(mt));

		//ʒuxNgƑxxNg
		particles.rs[0].set(0, 0, 0);
		particles.vs[0].set(0, 0, 0);
		particles.rs[1].set(0, 0, L);
		particles.vs[1].set(v0, 0, 0);		
		
		double dQ_ave = 0;
		//sCfbNX
		int n_f_box;
		int n_theta_now;

		double r_max = 0;

		int M = round((t_max - t_min) / dt);
		for (int i = 0; i <= M; i++) {
			double t = i * dt;

			if (i == 0) {

				//̏Ԃc
				n_theta_now = getThetaindex();
		
				//^͂͂OƂȂCfbNX^
				n_f_box = N_f_box/2;
				
				//Ԃ֗͂^
				particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / N_f_box;


			} else if ( i % int(interval/dt) == 0  ) {

				//s̏Ԃc
				int n_theta_next = getThetaindex();
				//std::cout << t << " " << particles.rs[0].x << " " << particles.rs[0].z << " " << particles.rs[1].x << " " << particles.rs[1].z << std::endl;
				//std::cout << n_theta_next << std::endl;

				//̌vZïʒuGlM[j
				double r = m * g * particles.rs[1].z;

				//
				if (particles.rs[1].z < 0) {
					r += r_failure;
				}
				//
				if (i == M) {
					success++;
					r += r_success;
					std::cout << success << " ";
				}

				double maxQ = 0;
				for (int j = 0; j <= N_f_box; j++) {
					if (maxQ < Q[j][n_theta_next]) {
						maxQ = Q[j][n_theta_next];
					}
				}

				double dQ = (r + gamma * maxQ - Q[n_f_box][n_theta_now]);

				//sl֐̍XV
				Q[n_f_box][n_theta_now]	= Q[n_f_box][n_theta_now] + eta * dQ;

				//dQ_ave += abs(dQ);

				////////////////////////////////////////////////////
				//̍švZX
				////////////////////////////////////////////////////
				n_theta_now = n_theta_next;

				maxQ = 0;
				int n_f_box_max = 10000;
				for (int j = 0; j <= N_f_box; j++) {
					if (maxQ < Q[j][n_theta_now]) {
						maxQ = Q[j][n_theta_now];
						n_f_box_max = j;
					}
				}
				//wK̏ꍇimaxQ=0j
				if (n_f_box_max == 10000) n_f_box_max = int(floor((N_f_box + 1) * rand_real_0_1(mt)));

				//n_f_box = n_f_box_max;

				if (rand_real_0_1(mt) < epsilon) {
					//s͍ő剿lsɌ
					n_f_box = n_f_box_max;
				}
				else {
					//s̓_Ɍ
					n_f_box = int(floor((N_f_box + 1) * rand_real_0_1(mt)));
				}

				//Ԃ֗͂^
				particles.fx = f_box_min + (f_box_max - f_box_min) * n_f_box / N_f_box;

				//Gs\[hI
				if (particles.rs[1].z < 0) {
					//std::cout << ":" << t << "[s]" << std::endl;
					if (i % int(interval / dt) / 10 == 0)  ofs0 << episode << " " << t << std::endl;
					break;
				}
			}
			
			//QENb^@ɂ鎞ԔW
			particles.timeEvolution(t);

			for (int n = 0; n < 2; n++) {
				//ʒu̍XV
				particles.rs[n] = particles.rs[n] + particles.drs[n];
				//x̍XV
				particles.vs[n] = particles.vs[n] + particles.dvs[n];
			}

		}
		if (episode % 100 == 0) {
			double p = double(success) / 100.0;
			ofs1 << episode << " " << p << std::endl;
			success = 0;
		}

		//double _L01 = Vector3::distance(particles.rs[1], particles.rs[0]);
		//std::cout << "dQ_ave=" << dQ_ave  << " L=" << (_L01 - L) << std::endl;
	}
	ofs0.close();
	ofs1.close();

	std::cout << "------------------------------" << std::endl;
	for (int j0 = 0; j0 < N_theta; j0++) {
		std::cout << "ԁF"<< j0 <<std::endl;

		for (int j1 = 0; j1 <= N_f_box; j1++) {
			std::cout << " " << Q[j1][j0];
		}
		std::cout << std::endl;
	}


	std::cout << "finished" << std::endl;

	int a;
	std::cin >> a;
	return a;

}

/*
gccRpC
g++ -c Vector3.cpp -std=c++14 -O2
g++ -c RK4_Nbody.cpp -std=c++14 -O2
g++ -c main.cpp -std=c++14 -O2
g++ main.o Vector3.o RK4_Nbody.o
*/
